1000 REMark               ----------------------
1005 REMark               *  HARD DISC BACKUP  *
1010 REMark               *  ~~~~~~~~~~~~~~~~  *
1015 REMark               * (C) Norman Dunbar  *
1020 REMark               * (C) 1990 - 93      *
1025 REMark               *                    *
1030 REMark               *    Version 2.00    *
1035 REMark               ----------------------
1040 :
1045 DATA_AREA 15: REMark ** Force TURBO to set up 15k dataspace **
1050 :
1055 IMPLICIT$ F1, F2, F3, F4, F5, SHIFT_F4, escape, enter, key
1060 IMPLICIT% main, title, printer, err_chan
1065 IMPLICIT% level, directories, files, f_archived, f_narchived
1070 IMPLICIT% disc_no, do_subs, list_on, fail, aborted
1075 IMPLICIT% error_df, error_nf, error_ro, date_set
1080 IMPLICIT% f_split, split_quit, f_missed
1085 IMPLICIT% list_only, do_all
1090 :
1095 IF COMPILED
1100   WHEN_ERROR 0
1105     kill_me
1110     CONTINUE
1115   END_WHEN
1120   init
1125   do_it_all
1130   shut_all_channels
1135 ELSE 
1140   CLS: PRINT 'WinBack MUST be compiled.': sing
1145 END IF 
1150 STOP
1155 :
1160 :
1165 DEFine PROCedure init
1170   :
1175   REMark ** Initialise variables, windows & defaults               **
1180   :
1185   init_default_vars
1190   init_defaults
1195   init_vars
1200   init_transient_vars
1205   init_windows
1210 END DEFine init
1215 :
1220 :
1225 DEFine PROCedure init_vars
1230   :
1235   REMark ** Initialise global variables                            **
1240   :
1245   screen_base = 0:    REMark ** holds address for storing screen
1250   DIM version$(4):    REMark ** which version of WinBack is this ?
1255   version$ = '2.22':  REMark ** As of 18th October 1993
1260   :
1265   DIM escape(1)
1270   DIM enter(1)
1275   DIM F1(1)
1280   DIM F2(1)
1285   DIM F3(1)
1290   DIM F4(1)
1295   DIM F5(1)
1300   DIM SHIFT_F4(1)
1305   DIM key(1)
1310   escape = CHR$(27):  REMark ** ESC INKEY$ value
1315   enter = CHR$(10):   REMark ** ENTER INKEY$ value
1320   F1 = CHR$(232):     REMark ** function key INKEY$ values
1325   F2 = CHR$(236)
1330   F3 = CHR$(240)
1335   F4 = CHR$(244)
1340   F5 = CHR$(248)
1345   SHIFT_F4 = CHR$(246)
1350   key = CHR$(0)
1355   :
1360   aborted = 0:       REMark ** in case ESC pressed during recursion
1365   error_nf = -7:     REMark ** Drive full
1370   error_df = -11:    REMark ** Not found
1375   error_ro = -20:    REMark ** Read only
1380   :
1385   main = 1:          REMark ** Main window channel
1390   title = 2:         REMark ** Title window channel
1395   err_chan = 0:      REMark ** Pop up error/message window
1400   date_set = 0:      REMark ** Forces user to set the clock
1405   list_only = 0:     REMark ** Backup or list only flag
1410   do_all = 0:        REMark ** Do all files or updated ones only
1415 END DEFine init_vars
1420 :
1425 :
1430 DEFine PROCedure init_transient_vars
1435   :
1440   REMark ** These variables get initialised after every run **
1445   :
1450   level = 0:          REMark ** sub-directory level so far
1455   directories = 0:    REMark ** how many directories processed so far
1460   file_size = 0:      REMark ** size of current file
1465   updated = 0:        REMark ** date file last updated (f.point)
1470   archived = 0:       REMark ** date file last backed up (f.point)
1475   files = 0:          REMark ** number of files processed
1480   f_archived = 0:     REMark ** number of files archived
1485   f_narchived = 0:    REMark ** number of files not archived
1490   t_file_size = 0:    REMark ** total size of files found
1495   t_archived = 0:     REMark ** total size of files archived
1500   disc_no = 0:        REMark ** current disc number
1505   free_space = 0:     REMark ** space left on current disc
1510   f_split = 0:        REMark ** number of files that were split
1515   split_quit = 0:     REMark ** number of splits that were quit
1520   f_missed = 0:       REMark ** number of files missed out
1525 END DEFine init_transient_vars
1530   :
1535   :
1540 DEFine PROCedure init_default_vars
1545   :
1550   REMark ** Initialise system defaults variables                   **
1555   :
1560   DIM o_dev$(5), prt$(41), baud$(5), list_on$(1)
1565   DIM top_dir$(40), do_sub$(1), do_all$(1)
1570   DIM device_range$(8)
1575   device_range$ = '12345678'
1580 END DEFine init_default_vars
1585 :
1590 :
1595 DEFine PROCedure init_windows
1600   :
1605   REMark ** Initialise window channels
1610   :
1615   IF TELL_MODE = 8 THEN MODE 4: END IF 
1620   OPEN #main, 'con_448x178a32x38'
1625   set_colours main, GREEN%, BLACK%, BLACK%, 1
1630   :
1635   OPEN #title, 'scr_448x22a32x16'
1640   show_title
1645   :
1650   OPEN #err_chan, 'con_444x44a34x107'
1655   PAPER #err_chan, WHITE%: INK #err_chan, BLACK%
1660 END DEFine init_vindows
1665 :
1670 :
1675 DEFine PROCedure init_defaults
1680   LOCal dummy$(41), space%
1685   :
1690   REMark ** read/set up system defaults **
1695   :
1700   RESTORE 1765
1705   READ dummy$
1710   READ  o_dev$, prt$, baud$, list_on$, top_dir$, do_sub$, do_all$
1715   space% = ' ' INSTR prt$
1720   IF space% THEN prt$ = prt$(1 TO space% - 1): END IF 
1725   space% = ' ' INSTR baud$
1730   IF space% THEN baud$ = baud$(1 TO space% - 1): END IF 
1735   space% = ' ' INSTR top_dir$
1740   IF space% THEN top_dir$ = top_dir$(1 TO space% - 1): END IF 
1745   :
1750   REMark ** initialise system defaults **
1755   REMark ***------> DO NOT CHANGE THE DATA LENGTHS OR ELSE <------***
1760   :
1765   DATA 'Winback defaults start'
1770   DATA 'flp1_'
1775   DATA 'ser1                                     '
1780   DATA '9600 '
1785   DATA 'y'
1790   DATA 'win1_                                   '
1795   DATA 'y'
1800   DATA 'u'
1805   :
1810   REMark ***------> DO NOT CHANGE THE DATA LENGTHS OR ELSE <------***
1815 END DEFine init_defaults
1820 :
1825 :
1830 DEFine PROCedure set_colours(chan%, p_col%, i_col%, b_col%, b_wide%)
1835   :
1840   REMark ** set colours & border in required channel **
1845   :
1850   PAPER #chan%, p_col%
1855   INK #chan%, i_col%
1860   BORDER #chan%, 0
1865   BORDER #chan%, b_wide%, b_col%
1870   CLS #chan%
1875 END DEFine set_colours
1880 :
1885 :
1890 DEFine PROCedure shut_all_channels
1895   LOCal chan
1900   :
1905   REMark ** Turbo does not like a parameterless 'close' so **
1910   REMark ** this procedure closes all open channels 0 - 15 **
1915   :
1920   FOR chan = 0 TO 15
1925     CLOSE #chan
1930   END FOR chan
1935 END DEFine shut_all_channels
1940 :
1945 :
1950 DEFine PROCedure do_it_all
1955   LOCal loop, col%, key(1), ok$(1), screen_base
1960   :
1965   REMark ** the main menu & loop **
1970   :
1975   col% = 26
1980   REPeat loop
1985     IF INKEY$ <> '' THEN NEXT loop: END IF 
1990     wide 'MAIN MENU'
1995     AT 5, col%
2000     PRINT 'F1   CREDITS'
2005     PRINT  TO col%; 'F2   SET SYSTEM CLOCK'
2010     PRINT  TO col%; 'F3   BACKUP HARD DISC'
2015     PRINT  TO col%; 'F4   BACKUP LISTING ONLY'
2020     PRINT
2025     PRINT  TO col%; 'ESC  QUIT PROGRAM';
2030     :
2035     key = get_a_key$
2040     SELect ON key
2045       = F1: credits
2050       = F2: set_clock 0
2055       = F3: list_only = 0: menu_2
2060       = F4: list_only = 1: menu_2
2065       = SHIFT_F4
2070             show_title
2075             set_colours main, GREEN%, BLACK%, BLACK%, 1
2080       = escape
2085             screen_base = POP_UP(#err_chan)
2090             CLS #err_chan
2095             INPUT #err_chan, 'Quit program y/n ? ';ok$
2100             POP_DOWN screen_base
2105             IF ok$ == 'y' THEN EXIT loop: END IF 
2110     END SELect 
2115   END REPeat loop
2120 END DEFine do_it_all
2125 :
2130 :
2135 DEFine PROCedure wide(t$)
2140   :
2145   REMark ** Print title in wide text **
2150   :
2155   CLS
2160   AT 2,0
2165   CSIZE 0, 1
2170   PRINT TO INT((74-LEN(t$))/2); t$
2175   CSIZE 0,0
2180 END DEFine wide
2185 :
2190 :
2195 DEFine PROCedure set_clock(forced%)
2200   LOCal year%, month%, day%, hour%, mins%, secs%
2205   LOCal month$(3), today$(20), col%, date_loop, m_loop
2210   LOCal tick_tock, ok$(1)
2215   :
2220   REMark ** Allows the user to set the clock **
2225   :
2230   col% = 29
2235   IF forced%
2240      sing
2245      wide 'You Must Set The Clock First !'
2250   ELSE 
2255      wide 'Set The Clock'
2260   END IF 
2265   REPeat date_loop
2270     today$ = DATE$
2275     year% = today$(1 TO 4)
2280     month$ = today$(6 TO 8)
2285     day% = today$(10 TO 11)
2290     hour% = today$(13 TO 14)
2295     mins% = today$(16 TO 17)
2300     secs% = today$(19 TO 20)
2305     AT 5, 0
2310     prompt 'Year   ', year%, 4
2315     prompt 'Month  ', month$, 3
2320     prompt 'Day    ', day%, 2
2325     prompt 'Hours  ', hour%, 2
2330     prompt 'Minutes', mins%, 2
2335     prompt 'Seconds', secs%, 2
2340     AT 5, col% + 10: year% = EDIT%(year%, 4)
2345     REPeat m_loop
2350       AT 6, col% + 10: month$ = EDIT$(month$, 3)
2355       IF check_month%(month$) THEN EXIT m_loop: END IF 
2360       buzz
2365     END REPeat m_loop
2370     month% = INT(((month$ INSTR 'janfebmaraprmayjunjulaugsepoctnovdec') + 3) /3)
2375     AT 7, col% + 10: day% = EDIT%(day%, 2)
2380     AT 8, col% + 10: hour% = EDIT%(hour%, 2)
2385     AT 9, col% + 10: mins% = EDIT%(mins%, 2)
2390     AT 10, col% + 10: secs% = EDIT%(secs%, 2)
2395     SDATE year%, month%, day%, hour%, mins%, secs%
2400     AT 13, col%: PRINT 'Correct y/n ? '
2405     REPeat tick_tock
2410       AT 12, col%: PRINT DATE$
2415       ok$ = INKEY$(#main, 1)
2420       IF ok$ == 'y' THEN EXIT date_loop: END IF 
2425       IF ok$ == 'n' THEN EXIT tick_tock: END IF 
2430     END REPeat tick_tock
2435     buzz
2440   END REPeat date_loop
2445   AT 13, col%: CLS 4: PRINT 'Clock set.'
2450   PAUSE 50
2455   date_set = 1
2460 END DEFine set_clock
2465 :
2470 :
2475 DEFine FuNction get_a_key$
2480   LOCal loop, key(1), valid$(7)
2485   :
2490   REMark ** Scan keyboard for FUNCTION keys or ESC **
2495   :
2500   valid$ = F1 & F2 & F3 & F4 & F5 & SHIFT_F4 & escape
2505   CURSOR_ON #main !
2510   drain_inkey$ #main
2515   REPeat loop
2520     key = INKEY$(#main, -1)
2525     IF key = enter THEN NEXT loop: END IF 
2530     IF key INSTR valid$ THEN EXIT loop: END IF 
2535     buzz
2540   END REPeat loop
2545   CURSOR_OFF #main
2550   RETurn key
2555 END DEFine get_a_key
2560 :
2565 :
2570 DEFine PROCedure menu_2
2575   LOCal loop, key(1), col%
2580   :
2585   REMark ** Allows changes to default devices prior to backup **
2590   REMark ** then does the backup by calling BACKUP_HARD_DISC  **
2595   :
2600   col% = 23
2605   REPeat loop
2610     IF INKEY$ <> '' THEN NEXT loop: END IF 
2615     IF list_only
2620        wide 'LISTING MENU'
2625     ELSE 
2630        wide 'BACKUP MENU'
2635     END IF 
2640     AT 5, col%
2645     PRINT 'F1   SET OUTPUT DEVICE'
2650     PRINT TO col%; 'F2   SET PRINT DEVICE'
2655     PRINT TO col%; 'F3   SET TOP DIRECTORY'
2660     PRINT TO col%; 'F4   PROCEED WITH ';
2665     IF list_only
2670        PRINT 'LISTING'
2675     ELSE 
2680        PRINT 'BACKUP'
2685     END IF 
2690     PRINT TO col%; 'F5   VIEW CURRENT DEFAULTS'
2695     PRINT
2700     PRINT TO col%; 'ESC  RETURN TO MAIN MENU';
2705     :
2710     key = get_a_key$
2715     IF key = escape THEN EXIT loop: END IF 
2720     SELect ON key
2725       = F1: set_output_device 0
2730       = F2: set_printer 0
2735       = F3: set_top_directory 0
2740       = F4: backup_hard_disc
2745       = F5: show_system_defaults
2750       = SHIFT_F4
2755             show_title
2760             set_colours #main, GREEN%, BLACK%, BLACK%, 1
2765     END SELect 
2770   END REPeat loop
2775 END DEFine menu_2
2780 :
2785 :
2790 DEFine PROCedure set_output_device(forced%)
2795   LOCal od_loop, col%
2800   :
2805   REMark ** Allows user to change output device **
2810   REMark ** Must be 5 chars long                **
2815   REMark ** Char 4 must be in range 1 - 8       **
2820   REMark ** Char 5 must be underscore           **
2825   :
2830   col% = 26
2835   IF forced%
2840      sing
2845      wide 'Set Output Device (Invalid Default)'
2850   ELSE 
2855      wide 'Set Output Device'
2860   END IF 
2865   REPeat od_loop
2870     AT 5, 0
2875     prompt 'Output device', o_dev$, 5
2880     AT 5, col% + 16: o_dev$ = EDIT$(o_dev$, 5)
2885     IF valid_device%(o_dev$, 5) THEN EXIT od_loop: END IF 
2890     buzz
2895   END REPeat od_loop
2900 END DEFine set_output_device
2905 :
2910 :
2915 DEFine FuNction valid_yn%(yn$)
2920   IF LEN(yn$) <> 1 THEN RETurn 0: END IF 
2925   RETurn (yn$ INSTR 'yn') <> 0
2930 END DEFine valid_yn%
2935 :
2940 :
2945 DEFine FuNction valid_device%(dev$, size)
2950   IF LEN(dev$) < 5 THEN RETurn 0: END IF 
2955   IF LEN(dev$) <> size THEN RETurn 0: END IF 
2960   IF dev$(4) INSTR '12345678' = 0 THEN RETurn 0: END IF 
2965   IF (dev$(5) <> '_') OR (dev$(size) <> '_') THEN RETurn 0: END IF 
2970   RETurn 1
2975 END DEFine valid_device%
2980 :
2985 :
2990 DEFine PROCedure set_printer(forced%)
2995   LOCal col%, y_loop, b_loop
3000   :
3005   REMark ** Allows user to select printer device and whether **
3010   REMark ** printing of file names etc is to be allowed      **
3015   REMark ** Printer may be 41 chars long                     **
3020   REMark ** device(5) + filename(36) = total 41              **
3025   :
3030   col% = 13
3035   IF forced%
3040      sing
3045      wide 'Set The Printer (Invalid Default)'
3050   ELSE 
3055      wide 'Set The Printer'
3060   END IF 
3065   AT 5, 0
3070   prompt 'Listing required ', list_on$, 1
3075   prompt 'Device / filename', prt$, 41
3080   prompt 'Baud rate        ', baud$, 5
3085   REPeat y_loop
3090     AT 5, col% + 20: list_on$ = EDIT$(list_on$, 1)
3095     IF valid_yn%(list_on$) THEN EXIT y_loop: END IF 
3100     buzz
3105   END REPeat y_loop
3110   list_on = (list_on$ == 'y')
3115   IF NOT (list_on) THEN RETurn : END IF 
3120   AT 6, col% + 20: prt$ = EDIT$(prt$, 41)
3125   REPeat b_loop
3130     AT 7, col% + 20: baud$ = EDIT$(baud$, 5)
3135     IF check_baud%(baud$) THEN EXIT b_loop: END IF 
3140     buzz
3145   END REPeat b_loop
3150 END DEFine set_printer
3155 :
3160 :
3165 DEFine PROCedure prompt(text$, default$, size)
3170   PRINT TO col%; text$ & ' : ' & default$;
3175   PRINT FILL$(' ', size - LEN(default$))
3180 END DEFine prompt
3185 :
3190 :
3195 DEFine PROCedure set_top_directory(forced%)
3200   LOCal col%, td_loop, s_loop, n_loop, a_loop
3205   :
3210   REMark ** Allows user to select top level directory and **
3215   REMark ** select whether to process sub-directories and **
3220   REMark ** whether to archive all files or updated ones. **
3225   REMark ** Max length for top directory is 40 chars      **
3230   REMark ** Char 4 in range 1 - 8                         **
3235   REMark ** Char 5 must be underscore as must last char   **
3240   REMark ** which could also be char 5 !                  **
3245   :
3250   col% = 11
3255   IF forced%
3260      sing
3265      wide 'Set Top Directory (Invalid Default)'
3270   ELSE 
3275      wide 'Set Top Directory'
3280   END IF 
3285   AT 5,0
3290   prompt 'Top directory       ', top_dir$, 40
3295   prompt 'Process sub-dirs    ', do_sub$, 1
3300   prompt 'All or Updated files', do_all$, 1
3305   REPeat td_loop
3310     REPeat n_loop
3315       AT 5, col% + 23: top_dir$ = EDIT$(top_dir$, 40)
3320       IF (valid_device%(top_dir$, LEN(top_dir$))) THEN EXIT n_loop
3325       buzz
3330     END REPeat n_loop
3335     IF FILE_type(top_dir$) = 255 THEN EXIT td_loop: END IF 
3340     buzz
3345   END REPeat td_loop
3350   REPeat s_loop
3355     AT 6, col% + 23: do_sub$ = EDIT$(do_sub$, 1)
3360     IF valid_yn%(do_sub$) THEN EXIT s_loop: END IF 
3365     buzz
3370   END REPeat s_loop
3375   do_subs = (do_sub$ == 'Y')
3380   REPeat a_loop
3385     AT 7, col% + 23: do_all$ = EDIT$(do_all$, 1)
3390     IF do_all$ == 'a' OR do_all$ == 'u' THEN EXIT a_loop: END IF 
3395     buzz
3400   END REPeat a_loop
3405   do_all = (do_all$ == 'A')
3410 END DEFine set_top_directory
3415 :
3420 :
3425 DEFine PROCedure backup_hard_disc
3430   LOCal dn_loop, curr_f$(1), err_loop, screen_base, oops, o_loop
3435   LOCal printer$(41), appending, where_to, text$(80)
3440   :
3445   REMark ** Now get on and back up the hard disc **
3450   :
3455   IF NOT (date_set)
3460      set_clock 1: REMark ** Force user to set the clock **
3465   END IF 
3470   IF NOT (valid_device%(o_dev$, 5))
3475     set_output_device 1
3480   END IF 
3485   IF NOT (valid_yn%(list_on$) AND check_baud%(baud$))
3490      set_printer 1
3495   END IF 
3500   IF NOT (valid_device%(top_dir$, LEN(top_dir$)) AND valid_yn%(do_sub$) AND do_all$ INSTR 'AaUu')
3505      set_top_directory 1
3510   END IF 
3515   :
3520   list_on = (list_on$ == 'Y')
3525   do_all = (do_all$ == 'A')
3530   do_subs = (do_sub$ == 'Y')
3535   :
3540   IF list_on
3545      printer$ = prt$
3550   ELSE 
3555      printer$ = "BLACK_HOLE"
3560   END IF 
3565   init_transient_vars: REMark ** Initialise for this run **
3570   REPeat err_loop
3575      printer = NEWCHAN%
3580      IF printer < 0
3585         abandon printer, 'Cannot open printer (' & printer$ & ')'
3590         NEXT err_loop
3595      END IF 
3600      IF printer > 15
3605        abandon -6,'Too many channels for TURBO to handle (backup)'
3610      ELSE 
3615         EXIT err_loop
3620      END IF 
3625   END REPeat err_loop
3630   REPeat o_loop
3635     appending = 0: REMark ** assume printer file not there **
3640     oops = DEVICE_STATUS(2, printer$)
3645     IF oops >= 0 THEN EXIT o_loop: END IF 
3650     IF oops = -20
3655        abandon oops, 'Printer filename is READ ONLY'
3660        NEXT o_loop
3665     END IF 
3670     IF oops = -8
3675        where_to = FILE_length(printer$)
3680        IF where_to < 0: where_to = 0: END IF 
3685        appending = 1
3690        OPEN #printer, printer$
3695        SET_POSITION #printer, where_to
3700        lprint CHR$(10): lprint CHR$(10): lprint CHR$(10)
3705        EXIT o_loop
3710     END IF 
3715     IF oops = -7
3720        abandon oops, 'Need a disc for ' & prt$ & ' !!!'
3725        NEXT o_loop
3730     END IF 
3735     IF oops = -11
3740        abandon oops, printer$ & ' is full, NO LISTING will be used'
3745        printer$ = 'BLACK_HOLE'
3750        NEXT o_loop
3755     END IF 
3760     abandon oops, 'Printer device/filename access error'
3765   END REPeat o_loop
3770   IF NOT appending
3775      OPEN_NEW #printer, printer$
3780   END IF 
3785   BAUD baud$
3790   text$ = 'WINBACK Version ' & version$ & ' - '
3795   IF list_only
3800      text$ = text$ & 'List of files to be backed up as at '
3805   ELSE 
3810      text$ = text$ & 'Hard Disc backed up on '
3815   END IF 
3820   text$ = text$ & DATE$ & CHR$(10)
3825   lprint text$
3830   IF do_all
3835      lprint 'Selecting ALL files.'
3840   ELSE 
3845      lprint 'Selecting UPDATED files.'
3850   END IF 
3855   lprint 'Top level directory  : ' & top_dir$
3860   text$ = 'With sub-directories : '
3865   IF do_subs
3870      lprint text$ & 'Yes'
3875   ELSE 
3880      lprint text$ & 'No'
3885   END IF 
3890   lprint 'Copying to           : ' & o_dev$
3895   lprint 'Listing to           : ' & printer$
3900   lprint 'Baud rate            : ' & baud$ & CHR$(10)
3905   tv
3910   :
3915   REMark ** Ask for first archive disc **
3920   :
3925   IF NOT (list_only)
3930      screen_base = POP_UP(#err_chan)
3935      BORDER #err_chan, 1, BLACK%
3940      sing
3945      REPeat dn_loop
3950        CLS #err_chan
3955        PRINT #err_chan, 'Put an archive disc in ' & o_dev$;
3960        PRINT #err_chan,' and type its number (0 to quit) ';
3965        disc_no = EDIT%(#err_chan, '', 3)
3970        IF disc_no < 0
3975           buzz
3980           NEXT dn_loop
3985        END IF 
3990        EXIT dn_loop
3995      END REPeat dn_loop
4000      BORDER #err_chan, 0
4005      POP_DOWN screen_base
4010   END IF 
4015   aborted = (disc_no = 0) - list_only
4020   IF NOT aborted THEN 
4025      update_free_space
4030      check_dir (top_dir$)
4035   END IF 
4040   IF aborted
4045      :
4050      REMark ** ESC pressed during run or 0 entered as disc number **
4055      :
4060      sing
4065      lprint CHR$(10)
4070      lprint '** WinBack abandoned by user **' & CHR$(10)
4075      CLOSE #printer
4080   ELSE 
4085      :
4090      REMark ** ESC not pressed - finished normally **
4095      :
4100      text$ = CHR$(10) & COMMA$(f_archived)
4105      IF f_archived = 1
4110         IF list_only
4115            lprint text$ & ' file will be archived.'
4120         ELSE 
4125            lprint text$ & ' file was archived.'
4130         END IF 
4135      ELSE 
4140         IF list_only
4145            lprint text$ & ' files will be archived.'
4150         ELSE 
4155            lprint text$ &  ' files were archived.'
4160         END IF 
4165      END IF 
4170      IF NOT (list_only)
4175         text$ = COMMA$(f_split)
4180         IF f_split = 1
4185            text$ = text$ & ' file was split'
4190         ELSE 
4195            text$ = text$ & ' files were split'
4200         END IF 
4205         text$ = text$ & ' with ' & split_quit & ' of these '
4210         lprint text$ & 'abandoned during the split.'
4215         text$ = COMMA$(f_missed)
4220         IF f_missed = 1
4225            text$ = text$ & ' file was missed'
4230         ELSE 
4235            text$ = text$ & ' files were missed'
4240         END IF 
4245         lprint text$ & ' (including those abandoned during split).'
4250         lprint COMMA$(t_archived) & ' bytes archived.'
4255      END IF 
4260      lprint CHR$(10) & '** WinBack finished at ' & DATE$ & ' **' & CHR$(10)
4265      CLOSE #printer
4270   END IF 
4275 END DEFine backup_hard_disc
4280 :
4285 :
4290 DEFine FuNction check_baud%(baud$)
4295  :
4300  REMark ** Check user input baud rate & return 1 if valid else 0   **
4305  :
4310  IF baud$ ==    '75' THEN RETurn 1: END IF 
4315  IF baud$ ==   '300' THEN RETurn 1: END IF 
4320  IF baud$ ==   '600' THEN RETurn 1: END IF 
4325  IF baud$ ==  '1200' THEN RETurn 1: END IF 
4330  IF baud$ ==  '2400' THEN RETurn 1: END IF 
4335  IF baud$ ==  '4800' THEN RETurn 1: END IF 
4340  IF baud$ ==  '9600' THEN RETurn 1: END IF 
4345  IF baud$ == '19200' THEN RETurn 1: END IF 
4350  RETurn 0
4355 END DEFine check_baud%
4360 :
4365 :
4370 DEFine PROCedure buzz
4375   BEEP 2000, 32000, 20, 250, 50
4380 END DEFine buzz
4385 :
4390 :
4395  DEFine PROCedure tv
4400   LOCal blank$(15)
4405   blank$ = '<' & FILL$(' ', 13) & '>'
4410   CLS
4415   CSIZE 0,1
4420   PRINT 'HARD DISC';
4425   CSIZE 0,0
4430   AT 2,0: PRINT 'Directory Level  <  >'
4435   PRINT 'Directories Processed <     > '
4440   PRINT 'Current Directory  <' & FILL$(' ', 40) & '>'
4445   PRINT
4450   PRINT 'Current File Name  <' & FILL$(' ', 36) & '>'
4455   PRINT 'Current File Size  ' & blank$
4460   PRINT 'File Last Updated  <                    >'
4465   PRINT 'File Last Archived <                    >'
4470   PRINT
4475   PRINT blank$ & ' files out of ' & blank$;
4480   IF list_only
4485      PRINT ' will be archived'
4490      PRINT
4495   ELSE 
4500      PRINT ' have been archived'
4505      PRINT blank$ & ' bytes out of ' & blank$ & ' have been archived'
4510   END IF 
4515   PRINT
4520   CSIZE 0,1
4525   PRINT 'FLOPPY DISC';
4530   CSIZE 0,0
4535   AT 16,0: PRINT 'Disc Number <   > has ' & blank$ & ' bytes free'
4540 END DEFine tv
4545 :
4550 :
4555 DEFine PROCedure update_tv(part)
4560   LOCal tv_col%, dummy$(13)
4565   :
4570   REMark ** Print statistics **
4575   :
4580   tv_col% = 20
4585   SELect ON part
4590   = 1
4595     dummy$ = COMMA$(level)
4600     AT 2, 18: PRINT dummy$(12 TO 13)
4605     dummy$ = COMMA$(directories)
4610     AT 3, 23: PRINT dummy$(9 TO 13)
4615     AT 4, tv_col%: PRINT curr_d$;
4620     PRINT FILL$(' ', 40 - LEN(curr_d$))
4625   = 2
4630     AT 6, tv_col%: PRINT curr_f$;
4635     PRINT FILL$(' ', 41 - LEN(curr_f$)); '>'
4640     AT 7, tv_col%: PRINT COMMA$(file_size)
4645     AT 8, tv_col%: PRINT DATE$(updated)
4650     AT 9, tv_col%: PRINT DATE$(archived)
4655     AT 11, 1: PRINT COMMA$(f_archived)
4660     AT 11, 30: PRINT COMMA$(files)
4665     IF NOT (list_only)
4670        AT 12, 1: PRINT COMMA$(t_archived)
4675        AT 12, 30: PRINT COMMA$(t_file_size)
4680     END IF 
4685   END SELect 
4690 END DEFine update_tv
4695 :
4700 :
4705 DEFine PROCedure show_free_space
4710     LOCal dummy$(13)
4715     dummy$ = COMMA$(disc_no)
4720     AT 16, 13: PRINT dummy$(11 TO 13)
4725     AT 16, 23: PRINT COMMA$(free_space);
4730 END DEFine update_tv
4735 :
4740 :
4745 DEFine PROCedure check_dir(d$)
4750   LOCal name_len%, curr_d$(40), curr_f$(41), entry$(64), loop
4755   LOCal qdos, err_loop, err1_loop, key(1)
4760   :
4765   REMark ** Process each directory entry in turn, ignoring nulls,  **
4770   REMark ** if a sub-directory is found, process it if required, if**
4775   REMark ** a data or program file is found then dump it to floppy **
4780   REMark ** if it has been updated since the last archive was done **
4785   :
4790   level = level + 1
4795   curr_d$ = d$
4800   REPeat err_loop
4805      qdos = FOPEN_DIRECTORY(curr_d$)
4810      IF qdos < 0
4815         abandon qdos, 'Cannot open directory ' & curr_d$
4820      ELSE 
4825         EXIT err_loop
4830      END IF 
4835   END REPeat err_loop
4840   directories = directories + 1
4845   update_tv 1
4850   REPeat loop
4855     IF END_OF_DIRECTORY(#qdos) THEN EXIT loop: END IF 
4860     CURSOR_ON #main !
4865     key = INKEY$(#main, 5)
4870     CURSOR_OFF #main
4875     IF key = escape
4880        aborted = 1: REMark ** Who pressed ESC then ? **
4885        EXIT loop
4890     END IF 
4895     IF key = SHIFT_F4
4900        show_title
4905        tv
4910        update_tv 1
4915        update_tv 2
4920        show_free_space
4925     END IF 
4930     entry$ = FREAD_DIRECTORY$(#qdos)
4935     IF entry$ = '' THEN NEXT loop: END IF 
4940     name_len% = word%(entry$(15 TO 16))
4945     IF NOT (name_len%) THEN NEXT loop: END IF 
4950     curr_f$ = curr_d$(1 TO 5) & entry$(17 TO (17 + name_len% - 1))
4955     IF CODE(entry$(6)) = 255
4960        :
4965        REMark ** Sub-directory **
4970        :
4975        IF do_subs
4980           :
4985           REMark ** Processing all sub-directories **
4990           :
4995           check_dir (curr_f$)
5000           IF aborted THEN EXIT loop : END IF 
5005           update_tv 1
5010        ELSE 
5015           :
5020           REMark ** Not processing any sub-directories **
5025           :
5030           NEXT loop
5035        END IF 
5040     ELSE 
5045        :
5050        REMark ** Data or program file **
5055        :
5060        REPeat err1_loop
5065          file_size = FILE_length(curr_f$)
5070          IF file_size < 0
5075             abandon file_size, 'Cannot read header of ' & curr_f$
5080             NEXT err1_loop
5085          END IF 
5090          EXIT err1_loop
5095        END REPeat err1_loop
5100        files = files + 1
5105        t_file_size = t_file_size + file_size
5110        updated = FILE_update(curr_f$)
5115        archived = FILE_backup(curr_f$)
5120        update_tv 2
5125        IF (updated > archived) OR do_all
5130           :
5135           REMark ** File updated since last backup taken or  **
5140           REMark ** the user requested all files be archived **
5145           :
5150           IF list_only
5155              f_archived = f_archived + 1
5160              lprint curr_f$
5165           ELSE 
5170              archive_file (curr_f$), (file_size)
5175           END IF 
5180        ELSE 
5185           :
5190           REMark ** File not changed since last backup taken **
5195           :
5200           f_narchived = f_narchived + 1
5205        END IF 
5210     END IF 
5215     update_tv 1
5220     update_tv 2
5225   END REPeat loop
5230   CLOSE_DIRECTORY #qdos
5235   level = level - 1
5240 END DEFine check_dir
5245 :
5250 :
5255 DEFine FuNction word%(word$)
5260   :
5265   REMark ** Extract a word sized integer from a 2 character string **
5270   :
5275   RETurn CODE(word$(1)) * 256 + CODE(word$(2))
5280 END DEFine word
5285 :
5290 :
5295 DEFine PROCedure abort_abort (fault%, message$)
5300   LOCal col%
5305   :
5310   REMark ** Oh dear, severe error has caused this run to give up ! **
5315   :
5320   col% = 16
5325   CLS
5330   CSIZE 0,1
5335   PRINT 'WINBACK ABANDONED'
5340   CSIZE 0,0
5345   sing
5350   AT 2,0
5355   PRINT 'A severe error has caused this run to be abandoned. ';
5360   PRINT 'Some details are givenbelow...'\\
5365   PRINT 'ERROR CODE   : ' & fault%
5370   PRINT 'QDOS TEXT    : ';: PRINT_ERROR$ fault%
5375   PRINT 'WINBACK TEXT : ' & message$
5380   PRINT
5385   lprint CHR$(10) & '** An error caused the run to be abandoned **'
5390   lprint CHR$(10) & CHR$(10) & 'Error Code   : ' & fault%
5395   REMark PRINT #printer,  'QDOS text    : ';
5400   REMark PRINT_ERROR$ #printer, fault%
5405   lprint 'WinBack text : ' &  message$ & CHR$(10)
5410   kill_me
5415   shut_all_channels
5420   STOP
5425 END DEFine abort_abort
5430 :
5435 :
5440 DEFine PROCedure archive_file(file$, w_size)
5445   LOCal check, f_size, err_loop, temp$(41)
5450   :
5455   REMark ** Check if enough space on current disc, copy file if so **
5460   REMark ** otherwise request a new disc with enough space then    **
5465   REMark ** copy to that one & update totals.                      **
5470   :
5475   f_size = 0
5480   temp$ = o_dev$ & file$(6 TO)
5485   check = DEVICE_STATUS(1, temp$)
5490   IF (check >= 0) OR (check = -8) OR (check = -20)
5495      :
5500      REMark ** An old archive is on this disc **
5505      :
5510      REPeat err_loop
5515         f_size = FILE_length(temp$)
5520         IF f_size < 0
5525            abandon f_size, 'Cannot open old ' & temp$
5530            NEXT err_loop
5535         END IF 
5540         EXIT err_loop
5545      END REPeat err_loop
5550   END IF 
5555   IF (free_space + f_size) >= w_size
5560      :
5565      REMark ** current disc has enough space including old archive **
5570      :
5575      copy_the_file (file$), (disc_no), (w_size)
5580   ELSE 
5585      :
5590      REMark ** current disc does not have enough space             **
5595      :
5600      request_and_copy (file$), (w_size)
5605   END IF 
5610 END DEFine archive_file
5615 :
5620 :
5625 DEFine PROCedure request_and_copy(file$, w_size)
5630   LOCal miss_out, split, oops
5635   :
5640   REMark ** No space on current disc so request another one until  **
5645   REMark ** we get one which has. Copy the file to it & update the **
5650   REMark ** totals. Allow user to miss out a file that is too big  **
5655   REMark ** or the file can be spilt over many discs.              **
5660   :
5665   miss_out = 0
5670   split = 0
5675   oops = 0
5680   request (file$), (w_size)
5685   IF split
5690      oops = split_file%((file$), (w_size))
5695      f_split = f_split + 1
5700      :
5705      REMark ** split returns 0 if ok or -1 if split failed **
5710      REMark ** or -2 if too many sections.                 **
5715      :
5720      IF oops
5725         :
5730         REMark ** Split failed for some reason **
5735         :
5740         lprint 'WARNING -> An error has occurred in splitting ' & file$
5745         lprint '           You are advised to delete and partial sections.'
5750         IF oops = -2
5755            :
5760            REMark ** Too many sections **
5765            :
5770            lprint 'Section 96 is the maximum allowed.' & CHR$(10)
5775         END IF 
5780      END IF 
5785      RETurn 
5790   END IF 
5795   IF miss_out
5800      f_missed = f_missed + 1
5805      lprint '***** ' & file$ & ' too big to copy, missed out *****'
5810      RETurn 
5815   END IF 
5820   copy_the_file (file$), (disc_no), (w_size)
5825 END DEFine request_and_copy
5830 :
5835 :
5840 DEFine PROCedure request(file$, w_size)
5845   LOCal loop, ok$(5), screen_base
5850   :
5855   REMark ** Request a disc for file$ with at least w_size bytes **
5860   :
5865   screen_base = POP_UP(#err_chan)
5870   BORDER #err_chan, 1, BLACK%
5875   REPeat loop
5880     disc_no = disc_no + 1
5885     CLS #err_chan
5890     PRINT #err_chan,'Not enough room on current disc to copy'\ file$
5895     sing
5900     PRINT #err_chan,'Insert archive disc ' & disc_no & ' and ';
5905     PRINT #err_chan,'press ENTER or'
5910     PRINT #err_chan, "Type 'MISS' to miss out or 'SPLIT' to ";
5915     INPUT #err_chan, 'split file ... ';ok$
5920     IF ok$ == 'miss' OR ok$ == 'split'
5925        disc_no = disc_no - 1
5930        IF ok$ == 'miss'
5935           miss_out = 1
5940        ELSE 
5945           split = 1
5950        END IF 
5955        EXIT loop
5960     END IF 
5965     update_free_space
5970     IF free_space >= w_size THEN EXIT loop: END IF 
5975   END REPeat loop
5980   BORDER #err_chan, 0
5985   POP_DOWN screen_base
5990 END DEFine request
5995 :
6000 :
6005 DEFine PROCedure copy_the_file(file$, disc, w_size)
6010   LOCal ch%, err_loop, ignore, right_now
6015   :
6020   REMark ** Strip off 'win1_', add on 'o_dev$' & copy the file to  **
6025   REMark ** o_dev$, update the totals & bale out                   **
6030   :
6035   WHEN_ERROR 1
6040   :
6045   REMark ** Note the lack of nesting here, more codes can be added **
6050   REMark ** so the lack of nesting make life easier (I think !)    **
6055   :
6060      IF ERNUM% = error_df
6065         :
6070         REMark ** Drive full - which it can be if the directory    **
6075         REMark ** eats up the last 3 sectors AFTER checking enough **
6080         REMark ** space on the disc for the data file.             **
6085         :
6090         request (file$), (w_size)
6095         RETRY
6100      END IF 
6105      :
6110      IF ERNUM% = error_ro
6115         :
6120         REMark ** Read only - Oh dear, how silly of me !           **
6125         :
6130         read_only
6135         RETRY
6140      END IF 
6145      :
6150      IF ERNUM% = error_nf
6155         :
6160         REMark ** Not found - oops, I thought it had finished and  **
6165         REMark ** I took the disk out.                             **
6170         :
6175         not_found
6180         RETRY
6185      ELSE 
6190         :
6195         REMark ** All other non trapped error codes **
6200         :
6205         PRINT #err_chan, 'Error ' & ERNUM% & ' at line ' & ERLIN%
6210         PRINT_ERROR$ #err_chan, ERNUM%
6215         kill_me
6220         CONTINUE
6225      END IF 
6230   END_WHEN
6235   :
6240   RETRY_HERE:         REMark ** Try, try, try again ! **
6245   :
6250   COPY_O file$ TO o_dev$ & file$(6 TO)
6255   right_now = DATE
6260   REPeat err_loop
6265      ch% = NEWCHAN%
6270      IF ch% > 15
6275         abandon -6, 'Too many channels for TURBO'
6280      ELSE 
6285         EXIT err_loop
6290      END IF 
6295   END REPeat err_loop
6300   OPEN_IN #ch%, file$
6305   SET_FBKDT #ch%, right_now
6310   CLOSE #ch%
6315   ignore = FSET_update(o_dev$ & file$(6 TO), updated)
6320   ignore = FSET_backup(o_dev$ & file$(6 TO), right_now)
6325   f_archived = f_archived + 1
6330   t_archived = t_archived + w_size
6335   lprint file$ & ' copied to disc ' & disc
6340   update_free_space
6345   :
6350   REMark ** Used to be free_space = free_space - w_size but .....  **
6355   REMark ** when the disc got full the directory took more room !! **
6360   :
6365   update_tv(1)
6370   update_tv(2)
6375 END DEFine copy_the_file
6380 :
6385 :
6390 DEFine PROCedure update_free_space
6395   LOCal err_loop
6400   :
6405   REMark ** calculate free space remaining on the current disc and **
6410   REMark ** update the global variable FREE_SPACE                  **
6415   :
6420   IF list_only: RETurn : END IF 
6425   REPeat err_loop
6430      free_space = DISC_space(o_dev$)
6435      IF free_space < 0
6440         abandon free_space, 'Cannot read free space on ' & o_dev$
6445         NEXT err_loop
6450      END IF 
6455      EXIT err_loop
6460   END REPeat err_loop
6465   show_free_space
6470 END DEFine update_free_space
6475 :
6480 :
6485 DEFine PROCedure sing
6490   :
6495   REMark ** make a noise to attract attention !!                   **
6500   :
6505   BEEP 9000, 4
6510 END DEFine sing
6515 :
6520 :
6525 DEFine FuNction check_month%(mon$)
6530   LOCal b$(4), month_name$(48)
6535   :
6540   REMark ** Check user input for month is valid **
6545   :
6550   month_name$ = 'Jan;Feb;Mar;Apr;May;Jun;Jul;Aug;Sep;Oct;Nov;Dec;'
6555   b$ = mon$ & ';'
6560   IF b$ = ';' THEN RETurn 0: END IF 
6565   IF b$ INSTR month_name$
6570      RETurn 1
6575   END IF 
6580   RETurn 0
6585 END DEFine check_month%
6590 :
6595 :
6600 DEFine PROCedure credits
6605   LOCal col%, ok$(1)
6610   :
6615   REMark ** Credit where it is due !!  **
6620   :
6625   col% = 9
6630   wide 'CREDITS - WinBack ' & version$
6635   AT 4,0
6640   PRINT 'AUTHOR - ';
6645   PRINT 'Norman Dunbar'
6650   PRINT TO col%; '12 Rainnieshill Road'
6655   PRINT TO col%; 'Newmachar'
6660   PRINT TO col%; 'Aberdeen'
6665   PRINT TO col%; 'AB2 0XG'
6670   PRINT
6675   PRINT "Compiled using DIGITAL PRECISION's TURBO compiler V2.04 ";
6680   PRINT '& Toolkit V2.10'
6685   PRINT 'Some routines by Simon N Goodwin & QL World DIY Toolkit'\\
6690   PRINT 'Copyright Norman Dunbar (Oct 1990, May 1991 onwards)'\\
6695   PRINT 'Press ENTER to return to MAIN MENU';
6700   ok$ = EDIT$('', 1)
6705 END DEFine credits
6710 :
6715 :
6720 DEFine PROCedure show_system_defaults
6725   LOCal col%, ok$(1)
6730   :
6735   REMark ** Display currently set system defaults **
6740   :
6745   col% = 11
6750   wide 'CURRENT DEFAULTS'
6755   AT 5,0
6760   PRINT TO col%; 'Output Device        : ' & o_dev$
6765   PRINT TO col%; 'Print Device         : ' & prt$
6770   PRINT TO col%; 'Baud Rate            : ' & baud$
6775   PRINT TO col%; 'List On              : ' & list_on$
6780   PRINT TO col%; 'Top Directory        : ' & top_dir$
6785   PRINT TO col%; 'Do Sub-directories   : ' & do_sub$
6790   PRINT TO col%; 'All or Updated files : ' & do_all$
6795   PRINT \\\ TO col%; 'Press ENTER to return to BACKUP MENU';
6800   ok$ = EDIT$('',1)
6805 END DEFine show_system_defaults
6810 :
6815 :
6820 DEFine FuNction get_a_chan%(device$)
6825   LOCal oops, chan%
6830   :
6835   REMark ** Open a channel to device$ but check that we do not go **
6840   REMark ** above channel 15 because TURBO will get in a knot !!  **
6845   REMark ** Return channel number or error code according to how  **
6850   REMark ** well the open works.                                  **
6855   :
6860   chan% = NEWCHAN%
6865   oops = DEVICE_STATUS(0, device$)
6870   IF oops < 0
6875      RETurn oops
6880   ELSE 
6885      OPEN #chan%, device$
6890   END IF 
6895   RETurn chan%
6900 END DEFine get_a_chan%
6905 :
6910 :
6915 DEFine PROCedure read_only
6920   LOCal ok$(1), screen_base
6925   :
6930   REMark ** Who tried to copy to a read only disc then ????  **
6935   REMark ** Inform user of the problem and allow corrections **
6940   REMark ** to be made, then return to try again.            **
6945   :
6950   screen_base = POP_UP(#err_chan)
6955   BORDER #err_chan, 1, BLACK%
6960   sing
6965   CLS #err_chan
6970   PRINT #err_chan, 'The disc in ' & o_dev$ & ' is READ ONLY !!'
6975   PRINT #err_chan, 'Remove it, write enable it, replace it ';
6980   INPUT #err_chan, 'and press ENTER...';ok$
6985   BORDER #err_chan, 0
6990   POP_DOWN screen_base
6995 END DEFine read_only
7000 :
7005 :
7010 DEFine PROCedure not_found
7015   LOCal ok$(1), screen_base
7020   :
7025   REMark ** Who took the disc out of o_dev$ then ? Trap this **
7030   REMark ** bit of sillyness and allow the user to continue  **
7035   :
7040   screen_base = POP_UP(#err_chan)
7045   BORDER #err_chan, 1, BLACK%
7050   sing
7055   CLS #err_chan
7060   PRINT #err_chan, 'Archive disc has been removed from ' & o_dev$ & ' !!'
7065   PRINT #err_chan, 'Put archive disc number ' & disc_no & ' back into ';
7070   INPUT #err_chan, (o_dev$) & ' and press ENTER...';ok$
7075   BORDER #err_chan, 0
7080   POP_DOWN screen_base
7085 END DEFine not_found
7090 :
7095 :
7100 DEFine PROCedure abandon(fault%, message$)
7105   LOCal screen_base, loop
7110   :
7115   REMark ** Prior to aborting, allow the user to retry when any of **
7120   REMark ** the really serious errors occur. V1.05 just aborted.   **
7125   :
7130   screen_base = POP_UP(#err_chan)
7135   BORDER #err_chan, 1, BLACK%
7140   sing
7145   CLS #err_chan
7150   PRINT #err_chan, 'An error has occurred - details are ...'
7155   PRINT #err_chan, 'ERROR CODE  : ' & fault% & '      QDOS TEXT : ';
7160   PRINT_ERROR$ #err_chan, fault%
7165   PRINT #err_chan, 'WINBACK TEXT : ' & message$
7170   PRINT #err_chan, 'Press ESC to abort or ENTER to retry ...';
7175   CURSOR_ON #err_chan !
7180   drain_inkey$ #err_chan
7185   REPeat loop
7190     key = INKEY$(#err_chan, -1)
7195     IF key = enter OR key = escape THEN EXIT loop: END IF 
7200     buzz
7205   END REPeat loop
7210   CURSOR_OFF #err_chan
7215   IF key = escape
7220      :
7225      REMark ** ESC pressed - abort **
7230      :
7235      abort_abort (fault%), (message$)
7240   END IF 
7245   BORDER #err_chan, 0
7250   POP_DOWN screen_base
7255 END DEFine abandon
7260 :
7265 :
7270 DEFine FuNction yes_or_no(channel%)
7275   LOCal key$(1), loop
7280   CURSOR_ON #channel% !
7285   drain_inkey$ #channel%
7290   REPeat loop
7295     key$ = INKEY$(#channel%, -1)
7300     IF key$ = '' THEN NEXT loop: END IF 
7305     IF key$ INSTR 'YN' THEN EXIT loop: END IF 
7310     buzz
7315   END REPeat loop
7320   CURSOR_OFF #channel%
7325   RETurn (key$ == 'Y')
7330 END DEFine yes_or_no
7335 :
7340 :
7345 DEFine PROCedure kill_me
7350   LOCal ok$(1)
7355   INPUT \\'Press ENTER to kill WinBack.....';ok$
7360 END DEFine kill_me
7365 :
7370 :
7375 DEFine PROCedure drain_inkey$(channel%)
7380   LOCal take_your_finger_off
7385   :
7390   REMark ** Removes any type ahead characters **
7395   :
7400   REPeat take_your_finger_off
7405     IF INKEY$(#channel%) = ''
7410        EXIT take_your_finger_off
7415     END IF 
7420   END REPeat take_your_finger_off
7425 END DEFine drain_inkey$
7430 :
7435 :
7440 DEFine PROCedure in_use
7445   LOCal ok$(1), screen_base
7450   :
7455   REMark ** The disc a file is being spilt onto is in use **
7460   :
7465   screen_base = POP_UP(#err_chan)
7470   BORDER #err_chan, 1, BLACK%
7475   sing
7480   CLS #err_chan
7485   PRINT #err_chan, 'The disc in ' & o_dev$ & ' is IN USE, probably ';
7490   PRINT #err_chan, 'by another task,'
7495   PRINT #err_chan, 'please remedy the situation ';
7500   INPUT #err_chan, 'and press ENTER...';ok$
7505   BORDER #err_chan, 0
7510   POP_DOWN screen_base
7515 END DEFine in_use
7520 :
7525 :
7530 DEFine PROCedure bad_medium
7535   LOCal ok$(1), screen_base
7540   :
7545   REMark ** The disc a file is being spilt onto is corrupt **
7550   :
7555   screen_base = POP_UP(#err_chan)
7560   BORDER #err_chan, 1, BLACK%
7565   sing
7570   CLS #err_chan
7575   PRINT #err_chan, 'The disc in ' & o_dev$ & ' is FAULTY / CORRUPT'
7580   INPUT #err_chan, 'press ENTER to continue ... ';ok$
7585   BORDER #err_chan, 0
7590   POP_DOWN screen_base
7595 END DEFine bad_medium
7600 :
7605 :
7610 DEFine PROCedure request_split
7615   LOCal ok$(4), screen_base, loop
7620   :
7625   REMark ** Request a new disc to split a file onto **
7630   :
7635   screen_base = POP_UP(#err_chan)
7640   BORDER #err_chan, 1, BLACK%
7645   REPeat loop
7650     CLS #err_chan
7655     sing
7660     disc_no = disc_no + 1
7665     PRINT #err_chan, 'Splitting : ' & curr_f$
7670     PRINT #err_chan, 'Insert archive disc ' & disc_no & ' and ';
7675     PRINT #err_chan, 'press ENTER ... '
7680     INPUT #err_chan, 'or type QUIT to abort the split ... ';ok$
7685     IF ok$ == 'quit'
7690        quit = 1
7695     END IF 
7700     update_free_space
7705     IF quit OR (free_space > 0) THEN EXIT loop: END IF 
7710   END REPeat loop
7715   BORDER #err_chan, 0
7720   POP_DOWN screen_base
7725   IF quit
7730      disc_no = disc_no - 1
7735      split_quit = split_quit + 1
7740   END IF 
7745 END DEFine request_split
7750 :
7755 :
7760 DEFine FuNction split_file%(curr_f$, size)
7765   LOCal quit, in, out, out_file$(41), section, loaded, saved
7770   LOCal max_buff, buff_addr, buff_size, oops, temp$(39), section_size
7775   LOCal failed, loop, check_in, check_out, out_loop, alloc_loop
7780   LOCal right_now, text$(256)
7785   :
7790   REMark ** Split the current file onto as many discs as required **
7795   REMark ** Return 0 if ok, else -1 for any error.                **
7800   :
7805   quit = 0
7810   max_buff = 30
7815   :
7820   REMark ** A bug in WCOPY/WREN etc removes a CHR$(0) from a file  **
7825   REMark ** name. Thus section starts at 1 and not zero.           **
7830   :
7835   section = 1
7840   failed = 0
7845   in = NEWCHAN%
7850   IF LEN(curr_f$) > 39
7855      abandon -15, 'File name (' & curr_f$ & ') is too big to split'
7860      RETurn -1
7865   END IF 
7870   REPeat alloc_loop
7875     IF max_buff < 1
7880        abandon -3, 'Cannot allocate a split buffer'
7885        RETurn -1
7890     END IF 
7895     buff_addr = ALLOCATION(max_buff * 1024)
7900     IF buff_addr > 0 THEN EXIT alloc_loop: END IF 
7905     max_buff = max_buff - 1
7910   END REPeat alloc_loop
7915   REPeat check_in
7920     oops = DEVICE_STATUS(1, curr_f$): REMark ** Read only **
7925     IF (oops >= 0) OR (oops = -20) OR (oops = -8)
7930        EXIT check_in
7935     ELSE 
7940        abandon oops, 'Cannot read ' & curr_f$
7945        NEXT check_in
7950     END IF 
7955   END REPeat check_in
7960   OPEN_IN #in, curr_f$
7965   lprint '===== Splitting ' & curr_f$
7970   temp$ = o_dev$ & curr_f$(6 TO) & '!'
7975   out = NEWCHAN%
7980   REPeat out_loop
7985     IF quit THEN CLOSE #in: RETurn -quit: END IF 
7990     out_file$ = temp$ & CHR$(section)
7995     REPeat check_out
8000       oops = DEVICE_STATUS(-1, out_file$): REMark ** IO_NAME **
8005       IF (oops >= 0) OR (oops = -8)
8010          EXIT check_out
8015       ELSE 
8020          SELect ON oops
8025            = -20
8030                read_only
8035            = -7
8040                not_found
8045            = -9
8050                in_use
8055            = -11
8060                 request_split
8065                 IF quit
8070                    CLOSE #in
8075                    failed = -1
8080                    EXIT check_out
8085                 END IF 
8090            = -16
8095                 bad_medium
8100                 request_split
8105                 IF quit
8110                    CLOSE #in
8115                    failed = -1
8120                    EXIT check_out
8125                 END IF 
8130            = REMAINDER 
8135                 abandon oops, 'Cannot create ' & temp$ & section
8140          END SELect 
8145          NEXT check_out
8150       END IF 
8155     END REPeat check_out
8160     IF failed
8165        DEALLOCATE buff_addr
8170        RETurn failed
8175     END IF 
8180     IF oops = -8
8185        DELETE out_file$
8190     END IF 
8195     OPEN_NEW #out, out_file$
8200     update_free_space
8205     IF free_space = 0
8210        :
8215        REMark ** Directory used last 3 sectors again **
8220        :
8225        CLOSE #out
8230        DELETE out_file$
8235        request_split
8240        NEXT out_loop
8245     END IF 
8250     section_size = 0
8255     REPeat load_loop
8260       IF EOF(#in) THEN EXIT load_loop: END IF 
8265       buffer_size = max_buff * 1024
8270       IF buffer_size > free_space
8275          buffer_size = free_space
8280       END IF 
8285       loaded = FLOAD_FILE(#in, buffer_size, buff_addr)
8290       IF loaded < 0
8295          abandon loaded, 'Error in partial load of ' & curr_f$
8300          failed = -1
8305          EXIT load_loop
8310       END IF 
8315       saved = FSAVE_FILE(#out, loaded, buff_addr)
8320       IF saved < 0
8325          abandon saved, 'Error writing to ' & temp$ & section
8330          failed = -1
8335          EXIT load_loop
8340       END IF 
8345       IF saved <> loaded
8350          abandon -16, 'Failed to write all bytes loaded to ' & temp$ & section
8355          failed = -1
8360          EXIT load_loop
8365       END IF 
8370       section_size = section_size + saved
8375       update_free_space
8380       :
8385       REMark ** Why won't next line work with "free_space = 0" ??? **
8390       REMark ** Even if free_space is 0 according to printout ???? **
8395       :
8400       IF free_space < 1 THEN EXIT load_loop: END IF 
8405     END REPeat load_loop
8410     CLOSE #out
8415     IF failed
8420        EXIT out_loop
8425     END IF 
8430     text$ = '      Section ' & section & ', ' & COMMA$(section_size)
8435     lprint text$ & ' bytes written to disc ' & disc_no
8440     IF section = 1
8445        right_now = DATE
8450        oops = FSET_type ((out_file$), (FILE_type (curr_f$)))
8455        IF oops < 0
8460           abandon oops, 'Cannot set file type for ' & temp$ & section
8465           failed = -1
8470           EXIT out_loop
8475        END IF 
8480        oops = FSET_data ((out_file$), (FILE_data (curr_f$)))
8485        IF oops < 0
8490           abandon oops, 'Cannot set file data for ' & temp$ & section
8495           failed = -1
8500           EXIT out_loop
8505        END IF 
8510        oops = FSET_update(out_file$, updated)
8515        oops = FSET_backup(out_file$, right_now)
8520     END IF 
8525     IF EOF(#in) THEN EXIT out_loop: END IF 
8530     request_split
8535     section = section + 1
8540     IF section = CODE('_')
8545        section = section + 1: REMark ** Screws WCOPY/WREN big time **
8550     END IF 
8555     IF section > 96
8560        quit = 2
8565     END IF 
8570   END REPeat out_loop
8575   IF failed
8580      RETurn failed
8585   END IF 
8590   SET_FBKDT #in, right_now
8595   CLOSE #in
8600   DEALLOCATE buff_addr
8605   f_archived = f_archived + 1
8610   t_archived = t_archived + size
8615   lprint '      Split ends.'
8620   update_free_space
8625   update_tv 1
8630   update_tv 2
8635   RETurn 0
8640 END DEFine split_file
8645 :
8650 :
8655 DEFine PROCedure show_title
8660   set_colours title, RED%, BLACK%, BLACK%, 1
8665   CSIZE #title, 0,1
8670   PRINT #title, TO 14; 'WINBACK - HARD DISC BACKUP (C) Norman Dunbar'
8675 END DEFine show_title
8680 :
8685 :
8690 DEFine PROCedure lprint(text$)
8695   LOCal old_printer$(41)
8700   :
8705   REMark ** An error trapped procedure to write to the printer **
8710   REMark ** which allows failure such as DRIVE_FULL etc to be  **
8715   REMark ** acted upon, this used to cause WinBack to give up  **
8720   REMark ** which is not suitable.
8725   REMark ** Change printer before ABANDON as ABORT_ABORT will  **
8730   REMark ** try to write to the printer if ESC pressed, this   **
8735   REMark ** Call here again and a loop could be possible.      **
8740   :
8745   WHEN_ERROR 1
8750     old_printer$ = printer$
8755     new_printer
8760     abandon ERNUM%, old_printer$ & ' error, turning off listing'
8765     RETRY
8770   END_WHEN
8775   :
8780   RETRY_HERE
8785     PRINT #printer, text$
8790 END DEFine lprint
8795 :
8800 :
8805 DEFine PROCedure new_printer
8810   :
8815   REMark ** Closes existing printer channel as an error has **
8820   REMark ** been detected, then continues the run with the  **
8825   REMark ** BLACK_HOLE used instead.                        **
8830   REMark ** No need to trap errors here as PRINTER is valid **
8835   REMark ** and the BLACK_HOLE open will always (?) work.   **
8840   REMark ** Famous last words !                             **
8845   :
8850   CLOSE #printer
8855   printer$ = 'BLACK_HOLE'
8860   OPEN #printer, printer$
8865 END DEFine new_printer
